<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <title>ast.ml &mdash; Coverage report</title>
    <meta name="description" content="64.50% coverage in lib/ast.ml">
    <link rel="stylesheet" href="../coverage.css"/>
    <script src="../highlight.pack.js"></script>
    <script>hljs.initHighlightingOnLoad();</script>
  </head>
  <body>
    <div id="header">
      <h1>
        <a href="../index.html">
          <span class="dirname">lib/</span>ast.ml
        </a>
      </h1>
      <h2>64.50%</h2>
    </div>
    <div id="navbar">
      <span class="unvisited" style="top:2.39%"></span>
      <span class="unvisited" style="top:10.05%"></span>
      <span class="unvisited" style="top:10.53%"></span>
      <span class="unvisited" style="top:11.00%"></span>
      <span class="unvisited" style="top:17.22%"></span>
      <span class="unvisited" style="top:17.70%"></span>
      <span class="unvisited" style="top:18.18%"></span>
      <span class="unvisited" style="top:18.66%"></span>
      <span class="unvisited" style="top:19.62%"></span>
      <span class="unvisited" style="top:20.10%"></span>
      <span class="unvisited" style="top:20.57%"></span>
      <span class="unvisited" style="top:21.53%"></span>
      <span class="unvisited" style="top:22.01%"></span>
      <span class="unvisited" style="top:22.49%"></span>
      <span class="unvisited" style="top:23.44%"></span>
      <span class="unvisited" style="top:23.92%"></span>
      <span class="unvisited" style="top:24.40%"></span>
      <span class="unvisited" style="top:24.88%"></span>
      <span class="unvisited" style="top:25.84%"></span>
      <span class="unvisited" style="top:26.32%"></span>
      <span class="unvisited" style="top:26.79%"></span>
      <span class="unvisited" style="top:27.75%"></span>
      <span class="unvisited" style="top:28.23%"></span>
      <span class="unvisited" style="top:28.71%"></span>
      <span class="unvisited" style="top:29.67%"></span>
      <span class="unvisited" style="top:30.14%"></span>
      <span class="unvisited" style="top:30.62%"></span>
      <span class="unvisited" style="top:31.10%"></span>
      <span class="unvisited" style="top:31.58%"></span>
      <span class="unvisited" style="top:32.54%"></span>
      <span class="unvisited" style="top:33.01%"></span>
      <span class="unvisited" style="top:33.49%"></span>
      <span class="unvisited" style="top:34.45%"></span>
      <span class="unvisited" style="top:34.93%"></span>
      <span class="unvisited" style="top:35.41%"></span>
      <span class="unvisited" style="top:36.36%"></span>
      <span class="unvisited" style="top:36.84%"></span>
      <span class="unvisited" style="top:37.32%"></span>
      <span class="unvisited" style="top:37.80%"></span>
      <span class="unvisited" style="top:38.28%"></span>
      <span class="unvisited" style="top:39.23%"></span>
      <span class="some-visited" style="top:40.67%"></span>
      <span class="some-visited" style="top:41.15%"></span>
      <span class="unvisited" style="bottom:11.96%"></span>
      <span class="unvisited" style="bottom:10.53%"></span>
      <span class="unvisited" style="bottom:10.05%"></span>
    </div>
    <div id="report">
      <div id="lines-layer">
        <pre>
<a id="L1"></a><span > </span>
<a id="L2"></a><span > </span>
<a id="L3"></a><span > </span>
<a id="L4"></a><span > </span>
<a id="L5"></a><span class="unvisited"> </span>
<a id="L6"></a><span > </span>
<a id="L7"></a><span > </span>
<a id="L8"></a><span > </span>
<a id="L9"></a><span > </span>
<a id="L10"></a><span > </span>
<a id="L11"></a><span > </span>
<a id="L12"></a><span > </span>
<a id="L13"></a><span > </span>
<a id="L14"></a><span class="visited"> </span>
<a id="L15"></a><span class="visited"> </span>
<a id="L16"></a><span > </span>
<a id="L17"></a><span > </span>
<a id="L18"></a><span > </span>
<a id="L19"></a><span > </span>
<a id="L20"></a><span > </span>
<a id="L21"></a><span class="unvisited"> </span>
<a id="L22"></a><span class="unvisited"> </span>
<a id="L23"></a><span class="unvisited"> </span>
<a id="L24"></a><span class="visited"> </span>
<a id="L25"></a><span > </span>
<a id="L26"></a><span > </span>
<a id="L27"></a><span > </span>
<a id="L28"></a><span > </span>
<a id="L29"></a><span > </span>
<a id="L30"></a><span > </span>
<a id="L31"></a><span > </span>
<a id="L32"></a><span > </span>
<a id="L33"></a><span > </span>
<a id="L34"></a><span > </span>
<a id="L35"></a><span class="visited"> </span>
<a id="L36"></a><span class="unvisited"> </span>
<a id="L37"></a><span class="unvisited"> </span>
<a id="L38"></a><span class="unvisited"> </span>
<a id="L39"></a><span class="unvisited"> </span>
<a id="L40"></a><span > </span>
<a id="L41"></a><span class="unvisited"> </span>
<a id="L42"></a><span class="unvisited"> </span>
<a id="L43"></a><span class="unvisited"> </span>
<a id="L44"></a><span > </span>
<a id="L45"></a><span class="unvisited"> </span>
<a id="L46"></a><span class="unvisited"> </span>
<a id="L47"></a><span class="unvisited"> </span>
<a id="L48"></a><span > </span>
<a id="L49"></a><span class="unvisited"> </span>
<a id="L50"></a><span class="unvisited"> </span>
<a id="L51"></a><span class="unvisited"> </span>
<a id="L52"></a><span class="unvisited"> </span>
<a id="L53"></a><span > </span>
<a id="L54"></a><span class="unvisited"> </span>
<a id="L55"></a><span class="unvisited"> </span>
<a id="L56"></a><span class="unvisited"> </span>
<a id="L57"></a><span > </span>
<a id="L58"></a><span class="unvisited"> </span>
<a id="L59"></a><span class="unvisited"> </span>
<a id="L60"></a><span class="unvisited"> </span>
<a id="L61"></a><span > </span>
<a id="L62"></a><span class="unvisited"> </span>
<a id="L63"></a><span class="unvisited"> </span>
<a id="L64"></a><span class="unvisited"> </span>
<a id="L65"></a><span class="unvisited"> </span>
<a id="L66"></a><span class="unvisited"> </span>
<a id="L67"></a><span > </span>
<a id="L68"></a><span class="unvisited"> </span>
<a id="L69"></a><span class="unvisited"> </span>
<a id="L70"></a><span class="unvisited"> </span>
<a id="L71"></a><span > </span>
<a id="L72"></a><span class="unvisited"> </span>
<a id="L73"></a><span class="unvisited"> </span>
<a id="L74"></a><span class="unvisited"> </span>
<a id="L75"></a><span > </span>
<a id="L76"></a><span class="unvisited"> </span>
<a id="L77"></a><span class="unvisited"> </span>
<a id="L78"></a><span class="unvisited"> </span>
<a id="L79"></a><span class="unvisited"> </span>
<a id="L80"></a><span class="unvisited"> </span>
<a id="L81"></a><span > </span>
<a id="L82"></a><span class="unvisited"> </span>
<a id="L83"></a><span class="visited"> </span>
<a id="L84"></a><span > </span>
<a id="L85"></a><span class="some-visited"> </span>
<a id="L86"></a><span class="some-visited"> </span>
<a id="L87"></a><span > </span>
<a id="L88"></a><span > </span>
<a id="L89"></a><span class="visited"> </span>
<a id="L90"></a><span > </span>
<a id="L91"></a><span class="visited"> </span>
<a id="L92"></a><span class="visited"> </span>
<a id="L93"></a><span class="visited"> </span>
<a id="L94"></a><span class="visited"> </span>
<a id="L95"></a><span class="visited"> </span>
<a id="L96"></a><span class="visited"> </span>
<a id="L97"></a><span class="visited"> </span>
<a id="L98"></a><span class="visited"> </span>
<a id="L99"></a><span class="visited"> </span>
<a id="L100"></a><span class="visited"> </span>
<a id="L101"></a><span class="visited"> </span>
<a id="L102"></a><span class="visited"> </span>
<a id="L103"></a><span class="visited"> </span>
<a id="L104"></a><span > </span>
<a id="L105"></a><span > </span>
<a id="L106"></a><span class="visited"> </span>
<a id="L107"></a><span class="visited"> </span>
<a id="L108"></a><span class="visited"> </span>
<a id="L109"></a><span class="visited"> </span>
<a id="L110"></a><span > </span>
<a id="L111"></a><span class="visited"> </span>
<a id="L112"></a><span > </span>
<a id="L113"></a><span > </span>
<a id="L114"></a><span > </span>
<a id="L115"></a><span class="visited"> </span>
<a id="L116"></a><span class="visited"> </span>
<a id="L117"></a><span class="visited"> </span>
<a id="L118"></a><span class="visited"> </span>
<a id="L119"></a><span class="visited"> </span>
<a id="L120"></a><span class="visited"> </span>
<a id="L121"></a><span > </span>
<a id="L122"></a><span class="visited"> </span>
<a id="L123"></a><span class="visited"> </span>
<a id="L124"></a><span class="visited"> </span>
<a id="L125"></a><span > </span>
<a id="L126"></a><span class="visited"> </span>
<a id="L127"></a><span class="visited"> </span>
<a id="L128"></a><span class="visited"> </span>
<a id="L129"></a><span class="visited"> </span>
<a id="L130"></a><span > </span>
<a id="L131"></a><span class="visited"> </span>
<a id="L132"></a><span class="visited"> </span>
<a id="L133"></a><span class="visited"> </span>
<a id="L134"></a><span > </span>
<a id="L135"></a><span class="visited"> </span>
<a id="L136"></a><span class="visited"> </span>
<a id="L137"></a><span class="visited"> </span>
<a id="L138"></a><span class="visited"> </span>
<a id="L139"></a><span class="visited"> </span>
<a id="L140"></a><span class="visited"> </span>
<a id="L141"></a><span class="visited"> </span>
<a id="L142"></a><span class="visited"> </span>
<a id="L143"></a><span > </span>
<a id="L144"></a><span class="visited"> </span>
<a id="L145"></a><span > </span>
<a id="L146"></a><span > </span>
<a id="L147"></a><span class="visited"> </span>
<a id="L148"></a><span class="visited"> </span>
<a id="L149"></a><span class="visited"> </span>
<a id="L150"></a><span class="visited"> </span>
<a id="L151"></a><span class="visited"> </span>
<a id="L152"></a><span class="visited"> </span>
<a id="L153"></a><span class="visited"> </span>
<a id="L154"></a><span class="visited"> </span>
<a id="L155"></a><span > </span>
<a id="L156"></a><span class="visited"> </span>
<a id="L157"></a><span class="visited"> </span>
<a id="L158"></a><span class="visited"> </span>
<a id="L159"></a><span class="visited"> </span>
<a id="L160"></a><span > </span>
<a id="L161"></a><span class="visited"> </span>
<a id="L162"></a><span > </span>
<a id="L163"></a><span > </span>
<a id="L164"></a><span > </span>
<a id="L165"></a><span class="visited"> </span>
<a id="L166"></a><span > </span>
<a id="L167"></a><span > </span>
<a id="L168"></a><span > </span>
<a id="L169"></a><span class="visited"> </span>
<a id="L170"></a><span > </span>
<a id="L171"></a><span > </span>
<a id="L172"></a><span > </span>
<a id="L173"></a><span class="visited"> </span>
<a id="L174"></a><span class="visited"> </span>
<a id="L175"></a><span > </span>
<a id="L176"></a><span > </span>
<a id="L177"></a><span > </span>
<a id="L178"></a><span class="visited"> </span>
<a id="L179"></a><span class="visited"> </span>
<a id="L180"></a><span > </span>
<a id="L181"></a><span > </span>
<a id="L182"></a><span class="visited"> </span>
<a id="L183"></a><span class="visited"> </span>
<a id="L184"></a><span class="unvisited"> </span>
<a id="L185"></a><span > </span>
<a id="L186"></a><span > </span>
<a id="L187"></a><span class="unvisited"> </span>
<a id="L188"></a><span class="unvisited"> </span>
<a id="L189"></a><span > </span>
<a id="L190"></a><span > </span>
<a id="L191"></a><span class="visited"> </span>
<a id="L192"></a><span class="visited"> </span>
<a id="L193"></a><span class="visited"> </span>
<a id="L194"></a><span class="visited"> </span>
<a id="L195"></a><span class="visited"> </span>
<a id="L196"></a><span class="visited"> </span>
<a id="L197"></a><span class="visited"> </span>
<a id="L198"></a><span class="visited"> </span>
<a id="L199"></a><span > </span>
<a id="L200"></a><span > </span>
<a id="L201"></a><span class="visited"> </span>
<a id="L202"></a><span class="visited"> </span>
<a id="L203"></a><span > </span>
<a id="L204"></a><span > </span>
<a id="L205"></a><span class="visited"> </span>
<a id="L206"></a><span class="visited"> </span>
<a id="L207"></a><span class="visited"> </span>
<a id="L208"></a><span > </span>
<a id="L209"></a><span > </span>
</pre>
      </div>
      <div id="text-layer">
        <pre id="line-numbers">
<a href="#L1">  1</a>
<a href="#L2">  2</a>
<a href="#L3">  3</a>
<a href="#L4">  4</a>
<a href="#L5">  5</a>
<a href="#L6">  6</a>
<a href="#L7">  7</a>
<a href="#L8">  8</a>
<a href="#L9">  9</a>
<a href="#L10"> 10</a>
<a href="#L11"> 11</a>
<a href="#L12"> 12</a>
<a href="#L13"> 13</a>
<a href="#L14"> 14</a>
<a href="#L15"> 15</a>
<a href="#L16"> 16</a>
<a href="#L17"> 17</a>
<a href="#L18"> 18</a>
<a href="#L19"> 19</a>
<a href="#L20"> 20</a>
<a href="#L21"> 21</a>
<a href="#L22"> 22</a>
<a href="#L23"> 23</a>
<a href="#L24"> 24</a>
<a href="#L25"> 25</a>
<a href="#L26"> 26</a>
<a href="#L27"> 27</a>
<a href="#L28"> 28</a>
<a href="#L29"> 29</a>
<a href="#L30"> 30</a>
<a href="#L31"> 31</a>
<a href="#L32"> 32</a>
<a href="#L33"> 33</a>
<a href="#L34"> 34</a>
<a href="#L35"> 35</a>
<a href="#L36"> 36</a>
<a href="#L37"> 37</a>
<a href="#L38"> 38</a>
<a href="#L39"> 39</a>
<a href="#L40"> 40</a>
<a href="#L41"> 41</a>
<a href="#L42"> 42</a>
<a href="#L43"> 43</a>
<a href="#L44"> 44</a>
<a href="#L45"> 45</a>
<a href="#L46"> 46</a>
<a href="#L47"> 47</a>
<a href="#L48"> 48</a>
<a href="#L49"> 49</a>
<a href="#L50"> 50</a>
<a href="#L51"> 51</a>
<a href="#L52"> 52</a>
<a href="#L53"> 53</a>
<a href="#L54"> 54</a>
<a href="#L55"> 55</a>
<a href="#L56"> 56</a>
<a href="#L57"> 57</a>
<a href="#L58"> 58</a>
<a href="#L59"> 59</a>
<a href="#L60"> 60</a>
<a href="#L61"> 61</a>
<a href="#L62"> 62</a>
<a href="#L63"> 63</a>
<a href="#L64"> 64</a>
<a href="#L65"> 65</a>
<a href="#L66"> 66</a>
<a href="#L67"> 67</a>
<a href="#L68"> 68</a>
<a href="#L69"> 69</a>
<a href="#L70"> 70</a>
<a href="#L71"> 71</a>
<a href="#L72"> 72</a>
<a href="#L73"> 73</a>
<a href="#L74"> 74</a>
<a href="#L75"> 75</a>
<a href="#L76"> 76</a>
<a href="#L77"> 77</a>
<a href="#L78"> 78</a>
<a href="#L79"> 79</a>
<a href="#L80"> 80</a>
<a href="#L81"> 81</a>
<a href="#L82"> 82</a>
<a href="#L83"> 83</a>
<a href="#L84"> 84</a>
<a href="#L85"> 85</a>
<a href="#L86"> 86</a>
<a href="#L87"> 87</a>
<a href="#L88"> 88</a>
<a href="#L89"> 89</a>
<a href="#L90"> 90</a>
<a href="#L91"> 91</a>
<a href="#L92"> 92</a>
<a href="#L93"> 93</a>
<a href="#L94"> 94</a>
<a href="#L95"> 95</a>
<a href="#L96"> 96</a>
<a href="#L97"> 97</a>
<a href="#L98"> 98</a>
<a href="#L99"> 99</a>
<a href="#L100">100</a>
<a href="#L101">101</a>
<a href="#L102">102</a>
<a href="#L103">103</a>
<a href="#L104">104</a>
<a href="#L105">105</a>
<a href="#L106">106</a>
<a href="#L107">107</a>
<a href="#L108">108</a>
<a href="#L109">109</a>
<a href="#L110">110</a>
<a href="#L111">111</a>
<a href="#L112">112</a>
<a href="#L113">113</a>
<a href="#L114">114</a>
<a href="#L115">115</a>
<a href="#L116">116</a>
<a href="#L117">117</a>
<a href="#L118">118</a>
<a href="#L119">119</a>
<a href="#L120">120</a>
<a href="#L121">121</a>
<a href="#L122">122</a>
<a href="#L123">123</a>
<a href="#L124">124</a>
<a href="#L125">125</a>
<a href="#L126">126</a>
<a href="#L127">127</a>
<a href="#L128">128</a>
<a href="#L129">129</a>
<a href="#L130">130</a>
<a href="#L131">131</a>
<a href="#L132">132</a>
<a href="#L133">133</a>
<a href="#L134">134</a>
<a href="#L135">135</a>
<a href="#L136">136</a>
<a href="#L137">137</a>
<a href="#L138">138</a>
<a href="#L139">139</a>
<a href="#L140">140</a>
<a href="#L141">141</a>
<a href="#L142">142</a>
<a href="#L143">143</a>
<a href="#L144">144</a>
<a href="#L145">145</a>
<a href="#L146">146</a>
<a href="#L147">147</a>
<a href="#L148">148</a>
<a href="#L149">149</a>
<a href="#L150">150</a>
<a href="#L151">151</a>
<a href="#L152">152</a>
<a href="#L153">153</a>
<a href="#L154">154</a>
<a href="#L155">155</a>
<a href="#L156">156</a>
<a href="#L157">157</a>
<a href="#L158">158</a>
<a href="#L159">159</a>
<a href="#L160">160</a>
<a href="#L161">161</a>
<a href="#L162">162</a>
<a href="#L163">163</a>
<a href="#L164">164</a>
<a href="#L165">165</a>
<a href="#L166">166</a>
<a href="#L167">167</a>
<a href="#L168">168</a>
<a href="#L169">169</a>
<a href="#L170">170</a>
<a href="#L171">171</a>
<a href="#L172">172</a>
<a href="#L173">173</a>
<a href="#L174">174</a>
<a href="#L175">175</a>
<a href="#L176">176</a>
<a href="#L177">177</a>
<a href="#L178">178</a>
<a href="#L179">179</a>
<a href="#L180">180</a>
<a href="#L181">181</a>
<a href="#L182">182</a>
<a href="#L183">183</a>
<a href="#L184">184</a>
<a href="#L185">185</a>
<a href="#L186">186</a>
<a href="#L187">187</a>
<a href="#L188">188</a>
<a href="#L189">189</a>
<a href="#L190">190</a>
<a href="#L191">191</a>
<a href="#L192">192</a>
<a href="#L193">193</a>
<a href="#L194">194</a>
<a href="#L195">195</a>
<a href="#L196">196</a>
<a href="#L197">197</a>
<a href="#L198">198</a>
<a href="#L199">199</a>
<a href="#L200">200</a>
<a href="#L201">201</a>
<a href="#L202">202</a>
<a href="#L203">203</a>
<a href="#L204">204</a>
<a href="#L205">205</a>
<a href="#L206">206</a>
<a href="#L207">207</a>
<a href="#L208">208</a>
<a href="#L209">209</a>
</pre>
<pre><code class="ocaml">open! Core

module Var = struct
  module T = struct
    <span data-count="0">t</span>ype t = int [@@deriving sexp, compare, quickcheck]
  end

  include T
  include Comparable.Make (T)

  let create =
    let next = ref 0 in
    fun () -&gt;
      <span data-count="1286227">I</span>nt.incr next;
      <span data-count="1286227">!</span>next
  ;;
end

module Kind = struct
  module T = struct
    <span data-count="0">t</span>ype t =
      <span data-count="0">|</span> Box
      <span data-count="0">|</span> Star
    [@@deriving sexp, compare, quickcheck<span data-count="3">]</span>
  end

  include T
  include Comparable.Make (T)

  let box = Box
  let star = Star
end

module Term = struct
  <span data-count="11275">t</span>ype t =
    <span data-count="0">|</span> Var of Var.t
    <span data-count="0">|</span> App of
        { <span data-count="0">f</span>un<span data-count="0">_</span> : t
        ; <span data-count="0">a</span>r<span data-count="0">g</span> : t
        }
    <span data-count="0">|</span> Fun of
        { <span data-count="0">b</span>inde<span data-count="0">r</span> : binder
        ; <span data-count="0">b</span>od<span data-count="0">y</span> : t
        }
    <span data-count="0">|</span> Pi of
        { <span data-count="0">b</span>inde<span data-count="0">r</span> : binder
        ; <span data-count="0">t</span>ype<span data-count="0">_</span> : t
        }
    <span data-count="0">|</span> Let of
        { <span data-count="0">b</span>inde<span data-count="0">r</span> : binder
        ; <span data-count="0">v</span>al<span data-count="0">_</span> : t
        ; <span data-count="0">i</span>n<span data-count="0">_</span> : t
        }
    <span data-count="0">|</span> Prod of
        { <span data-count="0">l</span>ef<span data-count="0">t</span> : t
        ; <span data-count="0">r</span>igh<span data-count="0">t</span> : t
        }
    <span data-count="0">|</span> Pair of
        { <span data-count="0">f</span>s<span data-count="0">t</span> : t
        ; <span data-count="0">s</span>n<span data-count="0">d</span> : t
        }
    <span data-count="0">|</span> Fst of t
    <span data-count="0">|</span> Snd of t
    <span data-count="0">|</span> Sum of
        { <span data-count="0">l</span>ef<span data-count="0">t</span> : t
        ; <span data-count="0">r</span>igh<span data-count="0">t</span> : t
        }
    <span data-count="0">|</span> Inl of
        { <span data-count="0">v</span>al<span data-count="0">_</span> : t
        ; <span data-count="0">t</span>ype<span data-count="0">_</span> : t
        }
    <span data-count="0">|</span> Inr of
        { <span data-count="0">v</span>al<span data-count="0">_</span> : t
        ; <span data-count="0">t</span>ype<span data-count="0">_</span> : t
        }
    <span data-count="0">|</span> Match of
        { <span data-count="0">m</span>atche<span data-count="0">e</span> : t
        ; <span data-count="0">i</span>n<span data-count="0">l</span> : case
        ; <span data-count="0">i</span>n<span data-count="0">r</span> : case
        ; <span data-count="0">t</span>ype<span data-count="0">_</span> : t
        }
    <span data-count="0">|</span> Kind of Kind.t
  [@@deriving sexp, quickcheck<span data-count="2">]</span>

  <span data-count="1">a</span>nd binder = <span data-count="0">V</span>ar.t * <span data-count="0">t</span>
  <span data-count="1">a</span>nd case = <span data-count="0">V</span>ar.t * <span data-count="18">t</span>

  let rec free_vars t =
    <span data-count="709894845">l</span>et module Set = Var.Set in
    match t with
    | <span data-count="314213437">V</span>ar var -&gt; Set.singleton var
    | <span data-count="129846974">F</span>un { binder = var, annot; body } | <span data-count="48577808">P</span>i { binder = var, annot; type_ = body } -&gt;
      Set.(union (free_var<span data-count="178424782">s</span> annot) (remov<span data-count="178424782">e</span> (free_var<span data-count="178424782">s</span> body) var))
    | <span data-count="46">L</span>et { binder = var, annot; val_; in_ } -&gt;
      Set.(union_list [ free_var<span data-count="46">s</span> annot; free_var<span data-count="46">s</span> val_; remov<span data-count="46">e</span> (free_var<span data-count="46">s</span> in_) var ])
    | <span data-count="173000856">A</span>pp { fun_ = t1; arg = t2 }
    | <span data-count="54">S</span>um { left = t1; right = t2 }
    | <span data-count="65">P</span>rod { left = t1; right = t2 }
    | <span data-count="43">P</span>air { fst = t1; snd = t2 } -&gt; Set.union (free_var<span data-count="173001018">s</span> t1) (free_var<span data-count="173001018">s</span> t2)
    | <span data-count="41">F</span>st t | <span data-count="52">S</span>nd t -&gt; free_vars t
    | <span data-count="62">I</span>nl { val_; type_ } | <span data-count="69">I</span>nr { val_; type_ } -&gt;
      Set.union (free_var<span data-count="131">s</span> val_) (free_var<span data-count="131">s</span> type_)
    | <span data-count="56">M</span>atch { matchee; inl = varl, tl; inr = varr, tr; type_ } -&gt;
      Set.(
        union_list
          [ free_var<span data-count="56">s</span> matchee
          ; free_var<span data-count="56">s</span> type_
          ; remov<span data-count="56">e</span> (free_var<span data-count="56">s</span> tl) varl
          ; remov<span data-count="56">e</span> (free_var<span data-count="56">s</span> tr) varr
          ])
    | <span data-count="44255282">K</span>ind _ -&gt; Set.empty
  ;;

  let rec subst t ~var ~term =
    <span data-count="7042528">l</span>et free_vars = free_vars term in
    <span data-count="7042528">l</span>et rec subst_abstraction ~constr ~binder:(var', annot) body =
      <span data-count="9128712">i</span>f Var.equal var var'
      then <span data-count="34">c</span>onstr (var', subst_ter<span data-count="34">m</span> annot) body
      else <span data-count="9128678">i</span>f Set.mem free_vars var'
      then <span data-count="5">(</span>
        let var'' = Var.create () in
        <span data-count="5">l</span>et body' = subst_var ~var:var' ~var':var'' body in
        <span data-count="5">c</span>onstr (var'', subst_ter<span data-count="5">m</span> annot) (subst_ter<span data-count="5">m</span> body'))
      else <span data-count="9128673">c</span>onstr (var', subst_ter<span data-count="9128673">m</span> annot) (subst_ter<span data-count="9128673">m</span> body)
    and subst_case (var', body) =
      <span data-count="172">i</span>f Var.equal var var'
      then <span data-count="1">v</span>ar', body
      else <span data-count="171">i</span>f Set.mem free_vars var'
      then <span data-count="2">(</span>
        let var'' = Var.create () in
        <span data-count="2">l</span>et body' = subst_var ~var:var' ~var':var'' body in
        <span data-count="2">v</span>ar'', subst_ter<span data-count="2">m</span> body')
      else <span data-count="169">v</span>ar', subst_ter<span data-count="169">m</span> body
    and subst_term t : t =
      <span data-count="206267791">m</span>atch t with
      | <span data-count="106495609">V</span>ar var' when Var.equa<span data-count="106495609">l</span> var var' -&gt; <span data-count="36728415">t</span>erm
      | <span data-count="90483267">A</span>pp { fun_; arg } -&gt; App { fun_ = subst_ter<span data-count="90483267">m</span> fun_; arg = subst_ter<span data-count="90483267">m</span> arg }
      | <span data-count="2847597">F</span>un { binder; body } -&gt;
        subst_abstraction ~constr:(fun binder body -&gt; <span data-count="2847597">F</span>un { binder; body }) ~binder body
      | <span data-count="6281088">P</span>i { binder; type_ } -&gt;
        subst_abstraction ~constr:(fun binder type_ -&gt; <span data-count="6281088">P</span>i { binder; type_ }) ~binder type_
      | <span data-count="27">L</span>et { binder; val_; in_ } -&gt;
        subst_abstraction
          ~constr:(fun binder in_ -&gt; <span data-count="27">L</span>et { binder; val_ = subst_ter<span data-count="27">m</span> val_; in_ })
          ~binder
          in_
      | <span data-count="85">P</span>air { fst; snd } -&gt; Pair { fst = subst_ter<span data-count="85">m</span> fst; snd = subst_ter<span data-count="85">m</span> snd }
      | <span data-count="54">F</span>st t -&gt; Fst (subst_ter<span data-count="54">m</span> t)
      | <span data-count="53">S</span>nd t -&gt; Snd (subst_ter<span data-count="53">m</span> t)
      | <span data-count="106">P</span>rod { left; right } -&gt; Prod { left = subst_ter<span data-count="106">m</span> left; right = subst_ter<span data-count="106">m</span> right }
      | <span data-count="99">S</span>um { left; right } -&gt; Sum { left = subst_ter<span data-count="99">m</span> left; right = subst_ter<span data-count="99">m</span> right }
      | <span data-count="68">I</span>nl { val_; type_ } -&gt; Inl { val_ = subst_ter<span data-count="68">m</span> val_; type_ = subst_ter<span data-count="68">m</span> type_ }
      | <span data-count="73">I</span>nr { val_; type_ } -&gt; Inr { val_ = subst_ter<span data-count="73">m</span> val_; type_ = subst_ter<span data-count="73">m</span> type_ }
      | <span data-count="86">M</span>atch { matchee; inl; inr; type_ } -&gt;
        Match
          { matchee = subst_ter<span data-count="86">m</span> matchee
          ; inl = subst_cas<span data-count="86">e</span> inl
          ; inr = subst_cas<span data-count="86">e</span> inr
          ; type_ = subst_ter<span data-count="86">m</span> type_
          }
      | <span data-count="159579">K</span>ind _ | <span data-count="69767194">V</span>ar _ -&gt; t
    in
    subst_term t

  and subst_var t ~var ~var' = <span data-count="977691">s</span>ubst t ~var ~term:(Var var')

  module Syntax = struct
    let app (fun_ : t) (args : t list) =
      <span data-count="644804">L</span>ist.fold_left args ~init:fun_ ~f:(fun fun_ arg -&gt; <span data-count="1283929">A</span>pp { fun_; arg })
    ;;

    let fun_ type_ body =
      <span data-count="957860">l</span>et x = Var.create () in
      <span data-count="957860">F</span>un { binder = x, type_; body = bod<span data-count="957860">y</span> (Var x) }
    ;;

    let ( @-&gt; ) kind type_ =
      <span data-count="328358">l</span>et a = Var.create () in
      <span data-count="328358">P</span>i { binder = a, kind; type_ = type<span data-count="328358">_</span> (Var a) }
    ;;

    let ( @=&gt; ) t1 t2 = <span data-count="325271">t</span>1 @-&gt; fun _ -&gt; <span data-count="325271">t</span>2
    let forall = ( @-&gt; <span data-count="1">)</span> (Kind Star)
    let ( @: ) t1 t2 = <span data-count="0">t</span>1, t2

    let let_ (val_, type_) ~in_ =
      <span data-count="0">l</span>et x = Var.create () in
      <span data-count="0">L</span>et { binder = x, type_; val_; in_ = in<span data-count="0">_</span> (Var x) }
    ;;

    let ( * ) left right = <span data-count="6">P</span>rod { left; right }
    let pair fst snd = <span data-count="3">P</span>air { fst; snd }
    let fst t = <span data-count="2">F</span>st t
    let snd t = <span data-count="2">S</span>nd t
    let ( + ) left right = <span data-count="4">S</span>um { left; right }
    let inl val_ ~type_ = <span data-count="2">I</span>nl { val_; type_ }
    let inr val_ ~type_ = <span data-count="2">I</span>nr { val_; type_ }
    let match_ matchee ~with_:(inl, inr) ~type_ = <span data-count="1">M</span>atch { matchee; inl; inr; type_ }

    let case body =
      <span data-count="2">l</span>et x = Var.create () in
      <span data-count="2">x</span>, bod<span data-count="2">y</span> (Var x)
    ;;

    let kind kind = <span data-count="2">K</span>ind kind
    let star = kin<span data-count="1">d</span> Star
    let box = kin<span data-count="1">d</span> Box
  end
end
</code></pre>
      </div>
    </div>
    <script src="../coverage.js"></script>
  </body>
</html>
